'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _taggedTemplateLiteral2;

function _load_taggedTemplateLiteral() {
  return _taggedTemplateLiteral2 = _interopRequireDefault(require('babel-runtime/helpers/taggedTemplateLiteral'));
}

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var parseStartOptionsAsync = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(projectDir, options) {
    var startOpts;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            startOpts = {};


            if (options.clear) {
              startOpts.reset = true;
            }

            if (options.maxWorkers) {
              startOpts.maxWorkers = options.maxWorkers;
            }

            if (!options.webOnly) {
              _context.next = 7;
              break;
            }

            startOpts.webOnly = options.webOnly;
            _context.next = 10;
            break;

          case 7:
            _context.next = 9;
            return (_xdl || _load_xdl()).Web.onlySupportsWebAsync(projectDir);

          case 9:
            startOpts.webOnly = _context.sent;

          case 10:
            return _context.abrupt('return', startOpts);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function parseStartOptionsAsync(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var action = function () {
  var _ref2 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(projectDir, options) {
    var rootPath, devToolsUrl, _ref3, exp, nonInteractive, startOpts, hasWebSupport, url, recipient;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            (0, (_exit || _load_exit()).installExitHooks)(projectDir);

            _context2.next = 3;
            return (_urlOpts || _load_urlOpts()).default.optsAsync(projectDir, options);

          case 3:

            (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.gray('Starting project at', projectDir));

            rootPath = _path.default.resolve(projectDir);
            _context2.next = 7;
            return (_devTools || _load_devTools()).DevToolsServer.startAsync(rootPath);

          case 7:
            devToolsUrl = _context2.sent;

            (0, (_log || _load_log()).default)('Expo DevTools is running at ' + (_chalk || _load_chalk()).default.underline(devToolsUrl));

            _context2.next = 11;
            return (_xdl || _load_xdl()).ProjectUtils.readConfigJsonAsync(projectDir);

          case 11:
            _ref3 = _context2.sent;
            exp = _ref3.exp;

            if (exp === null) {
              (_log || _load_log()).default.warn('No Expo configuration found. Are you sure this is a project directory?');
              process.exit(1);
            }

            nonInteractive = options.parent && options.parent.nonInteractive;

            if (!(!nonInteractive && !exp.isDetached)) {
              _context2.next = 24;
              break;
            }

            _context2.next = 18;
            return (_xdl || _load_xdl()).UserSettings.getAsync('openDevToolsAtStartup', true);

          case 18:
            if (!_context2.sent) {
              _context2.next = 23;
              break;
            }

            (0, (_log || _load_log()).default)('Opening DevTools in the browser... (press ' + (_chalk || _load_chalk()).default.bold(_templateObject) + ' to disable)');
            (0, (_opn || _load_opn()).default)(devToolsUrl, { wait: false });
            _context2.next = 24;
            break;

          case 23:
            (0, (_log || _load_log()).default)('Press ' + (_chalk || _load_chalk()).default.bold(_templateObject2) + ' to open DevTools now, or ' + (_chalk || _load_chalk()).default.bold(_templateObject) + ' to always open it automatically.');

          case 24:
            _context2.next = 26;
            return parseStartOptionsAsync(projectDir, options);

          case 26:
            startOpts = _context2.sent;
            _context2.next = 29;
            return (_xdl || _load_xdl()).Project.startAsync(rootPath, startOpts);

          case 29:
            _context2.next = 31;
            return (_xdl || _load_xdl()).Web.hasWebSupportAsync(projectDir);

          case 31:
            hasWebSupport = _context2.sent;

            if (!hasWebSupport) {
              _context2.next = 35;
              break;
            }

            _context2.next = 35;
            return (_xdl || _load_xdl()).Web.logURL(projectDir);

          case 35:
            _context2.next = 37;
            return (_xdl || _load_xdl()).UrlUtils.constructManifestUrlAsync(projectDir);

          case 37:
            url = _context2.sent;
            _context2.next = 40;
            return (_sendTo || _load_sendTo()).default.getRecipient(options.sendTo);

          case 40:
            recipient = _context2.sent;

            if (!recipient) {
              _context2.next = 44;
              break;
            }

            _context2.next = 44;
            return (_sendTo || _load_sendTo()).default.sendUrlAsync(url, recipient);

          case 44:
            _context2.next = 46;
            return (_urlOpts || _load_urlOpts()).default.handleMobileOptsAsync(projectDir, options);

          case 46:
            if (!(!nonInteractive && !exp.isDetached)) {
              _context2.next = 51;
              break;
            }

            _context2.next = 49;
            return (_TerminalUI || _load_TerminalUI()).startAsync(projectDir, startOpts);

          case 49:
            _context2.next = 52;
            break;

          case 51:
            if (!options.webOnly) {
              if (!exp.isDetached) {
                (_log || _load_log()).default.newLine();
                (_urlOpts || _load_urlOpts()).default.printQRCode(url);
              }
              (0, (_log || _load_log()).default)('Your native app is running at ' + (_chalk || _load_chalk()).default.underline(url));
            }

          case 52:
            (_log || _load_log()).default.nested((_chalk || _load_chalk()).default.green('Logs for your project will appear below. Press Ctrl+C to exit.'));

          case 53:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function action(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var _templateObject = (0, (_taggedTemplateLiteral2 || _load_taggedTemplateLiteral()).default)(['shift-d'], ['shift-d']),
    _templateObject2 = (0, (_taggedTemplateLiteral2 || _load_taggedTemplateLiteral()).default)(['d'], ['d']);

var _devTools;

function _load_devTools() {
  return _devTools = require('@expo/dev-tools');
}

var _xdl;

function _load_xdl() {
  return _xdl = require('xdl');
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _opn;

function _load_opn() {
  return _opn = _interopRequireDefault(require('opn'));
}

var _path = _interopRequireDefault(require('path'));

var _log;

function _load_log() {
  return _log = _interopRequireDefault(require('../log'));
}

var _sendTo;

function _load_sendTo() {
  return _sendTo = _interopRequireDefault(require('../sendTo'));
}

var _exit;

function _load_exit() {
  return _exit = require('../exit');
}

var _urlOpts;

function _load_urlOpts() {
  return _urlOpts = _interopRequireDefault(require('../urlOpts'));
}

var _TerminalUI;

function _load_TerminalUI() {
  return _TerminalUI = _interopRequireWildcard(require('./start/TerminalUI'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (program) {
  program.command('start [project-dir]').alias('r').description('Starts or restarts a local server for your app and gives you a URL to it').option('-s, --send-to [dest]', 'An email address to send a link to').option('-c, --clear', 'Clear the React Native packager cache').option('--web-only', 'Only start the webpack server')
  // TODO(anp) set a default for this dynamically based on whether we're inside a container?
  .option('--max-workers [num]', 'Maximum number of tasks to allow Metro to spawn.').urlOpts().allowOffline().asyncActionProjectDir(action, true, true);
};

module.exports = exports['default'];
//# sourceMappingURL=../__sourcemaps__/commands/start.js.map
